#include <windows.h>

#include "win015.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);

// Datos de la aplicacin
typedef struct stDatos {
   int Grupo1;
   int Grupo2;
} DATOS;

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground = GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 015",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           544,                 /* Ancho */
           375,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static DATOS Datos;
    static HINSTANCE hInstance;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           /* Inicializacin */
           Datos.Grupo1 = 1;
           Datos.Grupo2 = 2;
           return 0;
           break;
        case WM_COMMAND:
           if(LOWORD(wParam) == CM_DIALOGO)
              DialogBoxParam(hInstance, "DialogoPrueba", hwnd, (DLGPROC)DlgProc, (LPARAM)&Datos);
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

BOOL CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static DATOS *Datos;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_INITDIALOG:
           Datos = (DATOS*)lParam;
           // Estado inicial de los radiobuttons
           CheckRadioButton(hDlg, ID_RADIOBUTTON1, ID_RADIOBUTTON3,
              ID_RADIOBUTTON1+Datos->Grupo1-1);
           // Usando mensajes:
           SendDlgItemMessage(hDlg, ID_RADIOBUTTON4,
              BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
           SendDlgItemMessage(hDlg, ID_RADIOBUTTON5,
              BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
           SendDlgItemMessage(hDlg, ID_RADIOBUTTON6,
              BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
           SendDlgItemMessage(hDlg, ID_RADIOBUTTON4+Datos->Grupo2-1,
              BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
           SetFocus(GetDlgItem(hDlg, ID_RADIOBUTTON1));
           return FALSE;
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case ID_RADIOBUTTON4:
              case ID_RADIOBUTTON5:
              case ID_RADIOBUTTON6:
//                 SendDlgItemMessage(hDlg, ID_RADIOBUTTON4, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
//                 SendDlgItemMessage(hDlg, ID_RADIOBUTTON5, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
//                 SendDlgItemMessage(hDlg, ID_RADIOBUTTON6, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
//                 SendDlgItemMessage(hDlg, LOWORD(wParam), BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
                 CheckRadioButton(hDlg, ID_RADIOBUTTON4, ID_RADIOBUTTON6,
                    LOWORD(wParam));
                 return TRUE;
              case IDOK:
                 if(IsDlgButtonChecked(hDlg, ID_RADIOBUTTON1) == BST_CHECKED)
                    Datos->Grupo1 = 1;
                 else
                 if(IsDlgButtonChecked(hDlg, ID_RADIOBUTTON2) == BST_CHECKED)
                    Datos->Grupo1 = 2;
                 else
                    Datos->Grupo1 = 3;
                 if(SendDlgItemMessage(hDlg, ID_RADIOBUTTON4,
                    BM_GETCHECK, 0, 0) == BST_CHECKED) Datos->Grupo2 = 1;
                 else
                 if(SendDlgItemMessage(hDlg, ID_RADIOBUTTON5,
                    BM_GETCHECK, 0, 0) == BST_CHECKED) Datos->Grupo2 = 2;
                 else                                  Datos->Grupo2 = 3;
                 EndDialog(hDlg, FALSE);
                 return TRUE;
              case IDCANCEL:
                 EndDialog(hDlg, FALSE);
                 return FALSE;
            }
    }
    return FALSE;
}

